'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var common = require('@lezer/common');
var language = require('@codemirror/language');
var highlight = require('@codemirror/highlight');
var autocomplete = require('@codemirror/autocomplete');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 13,
  states: "!|QYQPOOOqQPO'#CiO!`QPO'#ChOOQO'#Cm'#CmQYQPOOOYQPO,58|OYQPO,58|OYQPO,58|OOQO,59S,59SO!gQPO,59SOOQO-E6g-E6gOOQO1G.h1G.hO#YQPO1G.hO#aQPO1G.hOOQO1G.n1G.n",
  stateData: "#h~O`OSPOS~ORROSROTROVROWROXROZQO~OVTOWUOXVOR]XS]XT]XZ]X^]XY]X~OYWO~PYOY^O~PYOVTORUiSUiTUiXUiZUi^UiYUi~OWUi~P!nOWUO~P!nO",
  goto: "!VbPPPPPPcPPPPPclPPPv_ROQSTUVXQSOQXQTYSXWPOQSXQZTQ[UR]V",
  nodeNames: "⚠ LineComment Query Identifier String Boolean BooleanExpression AND OR NOT ) ( Application",
  maxTerm: 17,
  nodeProps: [
    [common.NodeProp.openedBy, 10,"("],
    [common.NodeProp.closedBy, 11,")"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "(p~RbXY!ZYZ!Z]^!Zpq!Zrs!lst#Zxy#iyz#n}!O#s!Q![#s!]!^$X!c!d$d!d!p#s!p!q&Q!q!r'n!r!}#s#R#S#s#T#o#s~!`S`~XY!ZYZ!Z]^!Zpq!Z~!oTOr!lrs#Os#O!l#O#P#T#P~!l~#TOS~~#WPO~!l~#^Q#Y#Z#d#h#i#d~#iOT~~#nOZ~~#sOY~~#xTR~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s~$^QP~OY$XZ~$X~$iVR~}!O#s!Q![#s!c!p#s!p!q%O!q!}#s#R#S#s#T#o#s~%TVR~}!O#s!Q![#s!c!f#s!f!g%j!g!}#s#R#S#s#T#o#s~%qTV~R~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s~&VVR~}!O#s!Q![#s!c!q#s!q!r&l!r!}#s#R#S#s#T#o#s~&qVR~}!O#s!Q![#s!c!v#s!v!w'W!w!}#s#R#S#s#T#o#s~'_TX~R~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s~'sVR~}!O#s!Q![#s!c!t#s!t!u(Y!u!}#s#R#S#s#T#o#s~(aTW~R~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s",
  tokenizers: [0],
  topRules: {"Query":[0,2]},
  tokenPrec: 0
});

const simpleBooleanLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                Application: language.delimitedIndent({ closing: ")", align: false })
            }),
            language.foldNodeProp.add({
                Application: language.foldInside
            }),
            highlight.styleTags({
                "AND": highlight.tags.operatorKeyword,
                "OR": highlight.tags.operatorKeyword,
                "NOT": highlight.tags.operatorKeyword,
                Identifier: highlight.tags.variableName,
                Boolean: highlight.tags.bool,
                String: highlight.tags.string,
                LineComment: highlight.tags.lineComment,
                "( )": highlight.tags.paren
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
/**
 * Customizable autocomplete function for lang-simpleboolean
 * @param completeFromListParameter Completion[]
 * @returns CodeMirror autocomplete
 */
const simpleBooleanCompletion = (completeFromListParameter = []) => simpleBooleanLanguage.data.of({
    autocomplete: autocomplete.completeFromList(completeFromListParameter.concat([
        { label: "AND", type: "keyword" },
        { label: "OR", type: "keyword" },
        { label: "NOT", type: "keyword" }
    ]))
});
function simpleBoolean() {
    return new language.LanguageSupport(simpleBooleanLanguage);
}

exports.simpleBoolean = simpleBoolean;
exports.simpleBooleanCompletion = simpleBooleanCompletion;
exports.simpleBooleanLanguage = simpleBooleanLanguage;
